<template>
  <doc-app-navbar />

  <div class="doc-app">
    <doc-app-menu class="doc-app__menu" />

    <div class="doc-app__content">
      <doc-app-scroll-to-top id="__top__" tag="main">
        <router-view />
      </doc-app-scroll-to-top>
    </div>
  </div>
</template>

<script>
import DocAppMenu from './AppMenu.vue'
import DocAppNavbar from './AppNavbar.vue'
import DocAppScrollToTop from './AppScrollToTop.vue'

export default {
  name: 'DocApp',
  components: { DocAppNavbar, DocAppMenu, DocAppScrollToTop },
  data () {
    return {
      componentFilter: '',
      theme: null,
    }
  },
  computed: {
    componentsList () {
      const filter = this.componentFilter.toLowerCase()
      return this.$docs.componentNames.filter(name => name.toLowerCase().includes(filter)).sort()
    },
  },
  methods: {
    toggleTheme (value) {
      if (this.theme === value) value = null
      this.theme = value

      switch (value) {
        case 'dark':
          document.body.classList.remove('rui-theme--light')
          document.body.classList.add('rui-theme--dark')
          break
        case 'light':
          document.body.classList.add('rui-theme--light')
          document.body.classList.remove('rui-theme--dark')
          break
        default:
          document.body.classList.remove('rui-theme--light', 'rui-theme--dark')
      }
    },
    htmlIconClass (component) {
      return [
        this.$getDoc(component).examples.html.length > 0 || '-text--color-mute',
      ]
    },
    vueIconClass (component) {
      return [
        component.match(/^Rui/) || '-text--color-mute',
      ]
    },
    isDeprecated (component) {
      return this.$getDoc(component).deprecated
    },
  },
  created () {
    this.$setTitle('Documentation')
  },
}
</script>
